-- simple 16-bit 2-to-1 multiplexer constructed using single bit muxes
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity mux_2to1_1b is
    port ( 
		mux_select: in std_logic;
    data_a: in std_logic;
    data_b: in std_logic;
    data_out: out std_logic );
end mux_2to1_1b;

architecture behavioural of mux_2to1_1b is	  
begin
data_out <= data_a when mux_select = '0' else
            data_b when mux_select = '1' else
            'X';
end behavioural;



library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity mux_2to1_16b is
    port ( 
		mux_select: in std_logic;
    data_a: in std_logic_vector(15 downto 0);
    data_b: in std_logic_vector(15 downto 0);
    data_out: out std_logic_vector(15 downto 0) );
end mux_2to1_16b;

architecture structural of mux_2to1_16b is

component mux_2to1_1b is
    port ( 
		mux_select: in std_logic;
    data_a: in std_logic;
    data_b: in std_logic;
    data_out: out std_logic );
end component;

begin 
-- for loop to replicate 16 single-bit 2-to-1 mux  
-- what's the benefit of dong it this wa and not just work 
-- with the vectors diretly as in the description of the 1-bit version?
muxes: for i in 15 downto 0 generate
    bit_mux: mux_2to1_1b port map (
		mux_select => mux_select,
    data_a     => data_a(i),
    data_b     => data_b(i),
    data_out   => data_out(i) );
end generate muxes;
    
end structural;
